<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../xsl_util.xsl"/>

<xsl:output method="text" encoding="utf-8" indent="yes"/>

<xsl:template match="/">
    <xsl:variable name="component_name">
        <xsl:call-template name="replace">
            <xsl:with-param name="text" select="nerv_icde/component/name" />
            <xsl:with-param name="replace" select="' '" />
            <xsl:with-param name="by" select="'_'" />
        </xsl:call-template>
    </xsl:variable>
cmake_minimum_required(VERSION 2.6)
project("py_nerv<!--xsl:value-of select="$component_name"/-->")

SET(CMAKE_BUILD_TYPE MinSizeRel)

# set library path environment variable
if (MSVC)
    SET(Nerv_INCLUDE_DIR )
    SET(Nerv_LIBRARY_DIR )
    INCLUDE_DIRECTORIES(../src/include)
    INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR})
    INCLUDE_DIRECTORIES("C:/Program Files/Waregram/Nerv/usr/include")
    INCLUDE_DIRECTORIES("E:/Devtools/boost_1_72_0_msvc142_64")
    INCLUDE_DIRECTORIES("C:/Program Files/Python/include")    
    LINK_DIRECTORIES("C:/Program Files/Waregram/Nerv/usr/lib/x64")
    LINK_DIRECTORIES("C:/Program Files/Python/lib")
    LINK_DIRECTORIES("E:/Devtools/boost_1_72_0_msvc142_64/lib64-msvc-14.2")    
	ADD_DEFINITIONS(-D_USRDLL)
	add_compile_options("/utf-8")
	add_compile_options("/std:c++17")
	add_compile_options("/bigobj")
	add_compile_options("/wd4267")
else()
    # /usr/include : boost , nerv
    INCLUDE_DIRECTORIES(/usr/include/python3.7m)
    INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR})
    INCLUDE_DIRECTORIES(../src/include)
    <!-- LINK_DIRECTORIES(/usr/lib/x86_64-linux-gnu) -->
    ADD_DEFINITIONS(-DLINUX)
    add_compile_options("-std=c++17")
	add_compile_options("-fPIC")
endif()

ADD_DEFINITIONS(-DCPU_64)
ADD_DEFINITIONS(-DPY_NERV)

# set output directory
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)

# output setting
# ADD_EXECUTABLE (${PROJECT_NAME} ${CMAKE_SOURCE_DIR}/../src/py_nerv.cpp
ADD_LIBRARY(${PROJECT_NAME} SHARED ${CMAKE_SOURCE_DIR}/../src/py_nerv.cpp
<xsl:for-each select="/nerv_icde/component/proxy_list/row">${CMAKE_SOURCE_DIR}/../src/Nerv/Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cpp </xsl:for-each>
<xsl:for-each select="/nerv_icde/component/stub_list/row">${CMAKE_SOURCE_DIR}/../src/Nerv/Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cpp </xsl:for-each>)

# link library
if(MSVC)
    TARGET_LINK_LIBRARIES(${PROJECT_NAME} nerv_sdk_4)
    TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${PYTHON_LIBRARIES})
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES SUFFIX ".pyd")
else()
    TARGET_LINK_LIBRARIES(${PROJECT_NAME} python3.7m )
    TARGET_LINK_LIBRARIES(${PROJECT_NAME} boost_python37 )
    TARGET_LINK_LIBRARIES(${PROJECT_NAME} Nerv_General_SDK Nerv_General_Common)
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES PREFIX "")
endif()
</xsl:template>

</xsl:stylesheet>
