<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes" />
<xsl:template match="/">
import time
import threading
import signal
import sys
import py_nerv as nerv
import py_nerv_print_data as nprint
import py_nerv_set_data as nset

  <xsl:for-each select="/nerv_icde/component/stub_list/row">
    <xsl:variable name="method_domain_id" select="method_domain_id" />
    <xsl:variable name="interface_name" select="interface_name" />
    <xsl:variable name="class_name" select="class_name" />
class <xsl:value-of select="class_name"/>_py(nerv.<xsl:value-of select="class_name"/>):
    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:choose>
              <xsl:when test="type='CALL'">
                <xsl:choose>
                  <xsl:when test="in_data='(null)' and out_data='(null)'">
    def on_<xsl:value-of select="$method_name"/>(self, client_addr, in_elapsed_time, in_limit_time):
        print("py::on_<xsl:value-of select="$method_name"/>()")
        print(flush=True)
        return 0
                  </xsl:when>
                  <xsl:when test="in_data='(null)' and out_data!='(null)'">
    def on_<xsl:value-of select="$method_name"/>(self, client_addr, p_out, in_elapsed_time, in_limit_time):
        print("py::on_<xsl:value-of select="$method_name"/>()")
        print(flush=True)
        return 0
                  </xsl:when>
                  <xsl:when test="in_data!='(null)' and out_data='(null)'">
    def on_<xsl:value-of select="$method_name"/>(self, client_addr, p_in, in_elapsed_time, in_limit_time):
        print("py::on_<xsl:value-of select="$method_name"/>()")
        print(flush=True)
        return 0
                  </xsl:when>
                  <xsl:when test="in_data!='(null)' and out_data!='(null)'">
    def on_<xsl:value-of select="$method_name"/>(self, client_addr, p_in, p_out, in_elapsed_time, in_limit_time):
        print("py::on_<xsl:value-of select="$method_name"/>()")
        print(flush=True)
        return 0
                  </xsl:when>
                </xsl:choose>
    def on_<xsl:value-of select="$method_name"/>_cancel(self, client_addr, in_error):
        print("py::on_<xsl:value-of select="$method_name"/>_cancel()")
        print(flush=True)
        return 0
              </xsl:when>

              <xsl:when test="type='SIGNAL'">
                <xsl:choose >
                  <xsl:when test="in_data='(null)'">
    def on_<xsl:value-of select="$method_name"/>(self, client_addr, in_elapsed_time):
        print("py::on_<xsl:value-of select="$method_name"/>()")
        print(flush=True)
        return 0
                  </xsl:when>
                  <xsl:otherwise>
    def on_<xsl:value-of select="$method_name"/>(self, client_addr, p_in, in_elapsed_time):
        print("py::on_<xsl:value-of select="$method_name"/>()")
        print(flush=True)
        return 0
                  </xsl:otherwise>
                </xsl:choose >
    def on_<xsl:value-of select="$method_name"/>_cancel(self, client_addr, in_error):
        print("py::on_<xsl:value-of select="$method_name"/>_cancel()")
        print(flush=True)
              </xsl:when>

              <xsl:when test="type='EVENT'">
    def on_<xsl:value-of select="$method_name"/>_connect(self, client_addr, in_elapsed_time, in_limit_time):
        print("py::on_<xsl:value-of select="$method_name"/>_connect()")
        print(flush=True)
        return 0
    def on_<xsl:value-of select="$method_name"/>_shutdown(self, client_addr):
        print("py::on_<xsl:value-of select="$method_name"/>_shutdown()")
        print(flush=True)
              </xsl:when>

              <xsl:when test="type='COMMAND'">
    def on_<xsl:value-of select="$method_name"/>_connect(self, client_addr, in_elapsed_time, in_limit_time):
        print("py::on_<xsl:value-of select="$method_name"/>_connect()")
        print(flush=True)
        return 0
    def on_<xsl:value-of select="$method_name"/>_shutdown(self, client_addr):
        print("py::on_<xsl:value-of select="$method_name"/>_shutdown()")
        print(flush=True)
                <xsl:choose >
                  <xsl:when test="in_data='(null)'">
    def on_<xsl:value-of select="$method_name"/>_sync(self, client_addr, in_sync_model, in_elapsed, in_limit):
        print("py::on_<xsl:value-of select="$method_name"/>_sync()")
        print(flush=True)
                  </xsl:when>
                  <xsl:otherwise>
    def on_<xsl:value-of select="$method_name"/>_sync(self, client_addr, in_sync_model, in_elapsed, in_limit, pin_buffer):
        print("py::on_<xsl:value-of select="$method_name"/>_sync()")
        print(flush=True)
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>

              <xsl:when test="type='INFORMATION'">
    def on_<xsl:value-of select="$method_name"/>_connect(self, client_addr, in_tcp_request, in_elapsed_time, in_limit_time):
        print("py::on_<xsl:value-of select="$method_name"/>_connect()")
        print(flush=True)
        return 0
    def on_<xsl:value-of select="$method_name"/>_shutdown(self, client_addr):
        print("py::on_<xsl:value-of select="$method_name"/>_shutdown()")
        print(flush=True)
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>


  <xsl:for-each select="/nerv_icde/component/proxy_list/row">
    <xsl:variable name="method_domain_id" select="method_domain_id" />
    <xsl:variable name="interface_name" select="interface_name" />
    <xsl:variable name="class_name" select="class_name" />
class <xsl:value-of select="class_name"/>_py(nerv.<xsl:value-of select="class_name"/>):

    def on_object_create(self):
        print("py::on_object_create()")
        print(flush=True)
        connect_timeout = 1.0
    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:if test="type='COMMAND' or type='EVENT' or type='INFORMATION'">
        self.<xsl:value-of select="name"/>_connect(<xsl:if test="type='INFORMATION'">True, </xsl:if> connect_timeout, None )
            </xsl:if>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>

    def on_object_destroy(self):
        print("py::on_object_destroy()")
        print(flush=True)

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:choose>
              <xsl:when test="type='EVENT'">
    def on_<xsl:value-of select="$method_name"/>_disconnected(self):
        print("py::on_<xsl:value-of select="$method_name"/>_disconnected()")
        print(flush=True)
        return 0
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
    def on_<xsl:value-of select="$method_name"/>(self, in_elapsed_time):
        print("py::on_<xsl:value-of select="$method_name"/>()")
        print(flush=True)
                  </xsl:when>
                  <xsl:otherwise>
    def on_<xsl:value-of select="$method_name"/>(self, p_out, in_elapsed_time):
        print("py::on_<xsl:value-of select="$method_name"/>()")
        nprint.<xsl:value-of select="out_data"/>(p_out)
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>

              <xsl:when test="type='COMMAND'">
    def on_<xsl:value-of select="$method_name"/>_disconnected(self):
        print("py::on_<xsl:value-of select="$method_name"/>_disconnected()")
        print(flush=True)
              </xsl:when>


              <xsl:when test="type='INFORMATION'">
    def on_<xsl:value-of select="$method_name"/>_disconnected(self):
        print("py::on_<xsl:value-of select="$method_name"/>_disconnected()")
        print(flush=True)
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
    def on_<xsl:value-of select="$method_name"/>_sync(self, in_sync_model, in_elapsed_time, in_limit):
        print("py::on_<xsl:value-of select="$method_name"/>_sync()")
        print(flush=True)
                  </xsl:when>
                  <xsl:otherwise>
    def on_<xsl:value-of select="$method_name"/>_sync(self, in_sync_model, in_elapsed_time, in_limit, pin_buffer):
        print("py::on_<xsl:value-of select="$method_name"/>_sync(%d , %lf, %f)" % ( in_sync_model , in_elapsed_time, in_limit ) )
        # nprint.<xsl:value-of select="out_data"/>(pin_buffer)
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>

              <xsl:when test="type='BROADCAST'">
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
    void on_<xsl:value-of select="$param_method_name"/>_broadcast(const ::Nerv::server_addr_t&amp; in_server, const double&amp; in_elapsed_time)
                  </xsl:when>
                  <xsl:otherwise>
    def on_<xsl:value-of select="$method_name"/>_broadcast(self, in_server, pin_buf, in_elapsed_time):
        print("py::on_<xsl:value-of select="$method_name"/>_broadcast()")
        nprint.<xsl:value-of select="out_data"/>(pin_buf)
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>

if __name__ == '__main__':
    nerv.initialize()<xsl:text/>
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
<xsl:text>
    </xsl:text><xsl:value-of select="object_name"/> = <xsl:value-of select="../../class_name"/>_py()
    <xsl:value-of select="object_name"/>.create(nerv.get_<xsl:value-of select="../../method_domain_name"/>_port(),<xsl:value-of select="position()"/> )
  </xsl:for-each>

  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
<xsl:text>
    </xsl:text><xsl:value-of select="object_name"/> = <xsl:value-of select="../../class_name"/>_py()
    <xsl:value-of select="object_name"/>.create(nerv.get_<xsl:value-of select="../../method_domain_name"/>_port(), nerv.inet_addr("127.0.0.1") , <xsl:value-of select="position()"/>, 0 )
  </xsl:for-each>

    a = 0
    # main loop
    while True:
        time.sleep(1)
        a = a + 1
        a = a % 8

  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="out_data_domain_id" select="out_data_domain_id"/>
            <xsl:variable name="out_data" select="out_data"/>
            <xsl:variable name="in_data_domain_id" select="in_data_domain_id"/>
            <xsl:variable name="in_data" select="in_data"/>
            <xsl:variable name="in_original_type">
              <xsl:call-template name="get_original_type">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
                <xsl:with-param name="data" select="in_data" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_original_type">
              <xsl:call-template name="get_original_type">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
                <xsl:with-param name="data" select="out_data" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:if test="type='INFORMATION' and out_data!='(null)'">
              <xsl:variable name="data"><xsl:value-of select="$out_data"/></xsl:variable>
              <xsl:if test="$out_original_type='struct'">
<xsl:text>
        </xsl:text><xsl:value-of select="$data"/> = nerv.<xsl:value-of select="out_data"/>()<xsl:text/>
              </xsl:if>
<xsl:text>
        err = </xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_read(<xsl:value-of select="$data"/>)
        if not err:
            nprint.<xsl:value-of select="out_data"/>(<xsl:value-of select="out_data"/>)
            print(flush=True)
              <!-- <xsl:call-template name="print_data">
                <xsl:with-param name="tab" select="12" />
                <xsl:with-param name="right_var" select="$data" />
                <xsl:with-param name="domain_id" select="out_data_domain_id" />
                <xsl:with-param name="data_name" select="out_data" />
              </xsl:call-template> -->
            </xsl:if>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>

  </xsl:for-each>


  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="out_data_domain_id" select="out_data_domain_id"/>
            <xsl:variable name="out_data" select="out_data"/>
            <xsl:variable name="in_data_domain_id" select="in_data_domain_id"/>
            <xsl:variable name="in_data" select="in_data"/>
            <xsl:variable name="in_original_type">
              <xsl:call-template name="get_original_type">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
                <xsl:with-param name="data" select="in_data" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_original_type">
              <xsl:call-template name="get_original_type">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
                <xsl:with-param name="data" select="out_data" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:if test="(type='EVENT' or type='INFORMATION' or type='BROADCAST') and out_data!='(null)'">
              <xsl:variable name="data"><xsl:value-of select="$out_data"/></xsl:variable>
              <xsl:if test="$out_original_type='struct'">
<xsl:text>
        </xsl:text><xsl:value-of select="$data"/> = nerv.<xsl:value-of select="out_data"/>()<xsl:text/>
              </xsl:if>
        nset.<xsl:value-of select="out_data"/>(<xsl:value-of select="$data"/>, a )
        nprint.<xsl:value-of select="out_data"/>(<xsl:value-of select="$data"/>)
        print(flush=True)
              <xsl:choose>
                <xsl:when test="type='EVENT'">
                  <xsl:if test="out_data='(null)'">
<xsl:text>
        </xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>()
                  </xsl:if>
                  <xsl:if test="out_data!='(null)'">
<xsl:text>
        </xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>(<xsl:value-of select="$data"/>)
                  </xsl:if>
                </xsl:when>

                <xsl:when test="type='INFORMATION'">
                  <xsl:if test="out_data='(null)'">
<xsl:text>
        </xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write()
                  </xsl:if>
                  <xsl:if test="out_data!='(null)'">
<xsl:text>
        </xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write(<xsl:value-of select="$data"/>)
                  </xsl:if>
                </xsl:when>


                <xsl:when test="type='BROADCAST'">
                  <xsl:if test="out_data='(null)'">
<xsl:text>
        </xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_broadcast()
                  </xsl:if>
                  <xsl:if test="out_data!='(null)'">
<xsl:text>
        </xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_broadcast(<xsl:value-of select="$data"/>)
                  </xsl:if>
                </xsl:when>
              </xsl:choose>
            </xsl:if>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>

  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:choose>
              <xsl:when test="type='CALL'">
                <xsl:if test="in_data='(null)' and out_data='(null)'">
<xsl:text>
        </xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>( 1.0, None)
                </xsl:if>
                <xsl:if test="in_data!='(null)' and out_data='(null)'">
                  <xsl:variable name="data">in_data_<xsl:value-of select="position()"/></xsl:variable><xsl:text>
        </xsl:text><xsl:value-of select="$data"/> = nerv.<xsl:value-of select="in_data"/>()<xsl:text>
        </xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>(<xsl:value-of select="$data"/>, 1.0, None )
                </xsl:if>
                <xsl:if test="in_data='(null)' and out_data!='(null)'">
                  <xsl:variable name="data">out_data_<xsl:value-of select="position()"/></xsl:variable><xsl:text>
        </xsl:text><xsl:value-of select="$data"/> = nerv.<xsl:value-of select="out_data"/>()<xsl:text>
        </xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>(<xsl:value-of select="$data"/>, 1.0, None)
                </xsl:if>
                <xsl:if test="in_data!='(null)' and out_data!='(null)'">
                  <xsl:variable name="in_data">in_data_<xsl:value-of select="position()"/></xsl:variable>
                  <xsl:variable name="out_data">out_data_<xsl:value-of select="position()"/></xsl:variable><xsl:text>
        </xsl:text><xsl:value-of select="$in_data"/> = nerv.<xsl:value-of select="in_data"/>()<xsl:text>
        </xsl:text><xsl:value-of select="$out_data"/> = nerv.<xsl:value-of select="out_data"/>()<xsl:text>
        </xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>(<xsl:value-of select="$in_data"/>, <xsl:value-of select="$out_data"/> , 1.0, None)
                </xsl:if>
              </xsl:when>
              <xsl:when test="type='SIGNAL'">
                <xsl:if test="in_data='(null)'"><xsl:text>
        </xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>( 1.0, None)
                </xsl:if>
                <xsl:if test="in_data!='(null)'">
                  <xsl:variable name="data">in_data_<xsl:value-of select="position()"/></xsl:variable><xsl:text>
        </xsl:text><xsl:value-of select="$data"/> = nerv.<xsl:value-of select="in_data"/>()<xsl:text>
        </xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>(<xsl:value-of select="$data"/>, 1.0, None)
                </xsl:if>
              </xsl:when>
              <xsl:when test="type='COMMAND'">
                <xsl:if test="in_data='(null)'"><xsl:text>
        </xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write()
                </xsl:if>
                <xsl:if test="in_data!='(null)'">
                  <xsl:variable name="data">in_data_<xsl:value-of select="position()"/></xsl:variable><xsl:text>
        </xsl:text><xsl:value-of select="$data"/> = nerv.<xsl:value-of select="in_data"/>()<xsl:text>
        </xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write(<xsl:value-of select="$data"/>)
                </xsl:if>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>

</xsl:template>


</xsl:stylesheet>
